
#include <handler/handler.h>

// This line is to make sure we are hooking the same way were are calling
Handler::GateType test = &Handler::Gate;

#ifdef __linux__
	Vector Handler::Gate( void* arg1, Vector arg2, Vector arg3, float arg4, float arg5, int arg6, int arg7, int arg8, float arg9, entvars_s* arg10, bool arg11, int arg12 )
#else
	Vector* _fastcall Handler::Gate( void* arg1, DUMMY, Vector* origReturn, Vector arg2, Vector arg3, float arg4, float arg5, int arg6, int arg7, int arg8, float arg9, entvars_s* arg10, bool arg11, int arg12 )
#endif
	{
		FunctionForHandler* function = Rage->init();

		Handler* handler = static_cast<Handler*>(function->get_handler());
	
		CVector<int>* plugin_hooks = function->get_plugin_hooks();
		CVector<void*>* module_hooks =  function->get_module_hooks();

		handler->init( arg1 ,arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12 );

		RageHookReturn hook_ret = RageHookIgnored;
	
		handler->call_module_hooks( module_hooks[RageHookPre], hook_ret );

		handler->call_plugin_hooks( plugin_hooks[RageHookPre], hook_ret, RageHookPre );

		handler->call_original( function, hook_ret );
		
		handler->call_module_hooks( module_hooks[RageHookPost], hook_ret );
	
		handler->call_plugin_hooks( plugin_hooks[RageHookPost], hook_ret, RageHookPost );

		Vector ret = handler->end();

		Rage->end();

#ifdef __linux__
		return ret;
#else
		memcpy( origReturn, ret, sizeof( ret ) );
		return origReturn;
#endif
	}

void Handler::init( void* arg1, Vector arg2, Vector arg3, float arg4, float arg5, int arg6, int arg7, int arg8, float arg9, entvars_s* arg10, bool arg11, int arg12 )
{
	this->Data.Arguments.arg1 = arg1;
	this->Data.Arguments.arg2 = arg2;
	this->Data.Arguments.arg3 = arg3;
	this->Data.Arguments.arg4 = arg4;
	this->Data.Arguments.arg5 = arg5;
	this->Data.Arguments.arg6 = arg6;
	this->Data.Arguments.arg7 = arg7;
	this->Data.Arguments.arg8 = arg8;
	this->Data.Arguments.arg9 = arg9;
	this->Data.Arguments.arg10 = arg10;
	this->Data.Arguments.arg11 = arg11;
	this->Data.Arguments.arg12 = arg12;

	convertArgumentsToAMXX();
}

void Handler::convertArgumentsToAMXX()
{
	this->Data.ArgumentsAMXX.arg1 = Rage->private_to_index( this->Data.Arguments.arg1 );
	this->Data.ArgumentsAMXX.arg4 = this->Data.Arguments.arg4;
	this->Data.ArgumentsAMXX.arg5 = this->Data.Arguments.arg5;
	this->Data.ArgumentsAMXX.arg6 = this->Data.Arguments.arg6;
	this->Data.ArgumentsAMXX.arg7 = this->Data.Arguments.arg7;
	this->Data.ArgumentsAMXX.arg8 = this->Data.Arguments.arg8;
	this->Data.ArgumentsAMXX.arg9 = this->Data.Arguments.arg9;
	this->Data.ArgumentsAMXX.arg10 = Rage->entvar_to_index( this->Data.Arguments.arg10 );
	this->Data.ArgumentsAMXX.arg11 = this->Data.Arguments.arg11;
	this->Data.ArgumentsAMXX.arg12 = this->Data.Arguments.arg12;
}

void Handler::call_original( FunctionForHandler* function, RageHookReturn& ret )
{
	if( ret == RageHookSupercede )
		return;

	GateType original_address = (GateType) function->get_original_address();
	
	function->pre_call();
	
	Vector orig_ret;

#ifdef __linux__
	orig_ret = original_address
	(
		Data.Arguments.arg1,
		Data.Arguments.arg2,
		Data.Arguments.arg3,
		Data.Arguments.arg4,
		Data.Arguments.arg5,
		Data.Arguments.arg6,
		Data.Arguments.arg7,
		Data.Arguments.arg8,
		Data.Arguments.arg9,
		Data.Arguments.arg10,
		Data.Arguments.arg11,
		Data.Arguments.arg12
	);
#else
	original_address
	(
		Data.Arguments.arg1,
		DUMMY_VAL,
		&orig_ret,
		Data.Arguments.arg2,
		Data.Arguments.arg3,
		Data.Arguments.arg4,
		Data.Arguments.arg5,
		Data.Arguments.arg6,
		Data.Arguments.arg7,
		Data.Arguments.arg8,
		Data.Arguments.arg9,
		Data.Arguments.arg10,
		Data.Arguments.arg11,
		Data.Arguments.arg12
	);
#endif
		
	function->post_call();

	if( ret != RageHookOverride )
	{
		Data.Return = orig_ret;
	}
}

Vector Handler::end()
{
	return this->Data.Return;
}

void Handler::call_plugin_hooks( CVector<int>& hooks, RageHookReturn& ret, RageHookPhase rage_hook_phase )
{
	if( ret != RageHookIgnored )
		return;

	if( !hooks.size() )
		return;

	switch( rage_hook_phase )
	{
		case RageHookPre :
		{
			this->rage_get_return_current = &Handler::rage_get_return_pre;
			break;
		}
		case RageHookPost :
		{
			this->rage_get_return_current = &Handler::rage_get_return_normal;
			break;
		}
	}

	this->rage_set_return_current = &Handler::rage_set_return_normal;
	this->rage_set_param_current = &Handler::rage_set_param_normal;
		
	for( unsigned int i = 0; i < hooks.size(); i++ )
	{
		Data.ArgumentsAMXX.arg2 = MF_PrepareCellArray( reinterpret_cast< cell* >( &Data.Arguments.arg2 ), 3 );
		Data.ArgumentsAMXX.arg3 = MF_PrepareCellArray( reinterpret_cast< cell* >( &Data.Arguments.arg3 ), 3 );

		ret = (RageHookReturn) MF_ExecuteForward
		( 
			hooks[i], 
			Data.ArgumentsAMXX.arg1, 
			Data.ArgumentsAMXX.arg2,
			Data.ArgumentsAMXX.arg3,
			Data.ArgumentsAMXX.arg4,
			Data.ArgumentsAMXX.arg5,
			Data.ArgumentsAMXX.arg6,
			Data.ArgumentsAMXX.arg7,
			Data.ArgumentsAMXX.arg8,
			Data.ArgumentsAMXX.arg9,
			Data.ArgumentsAMXX.arg10,
			Data.ArgumentsAMXX.arg11,
			Data.ArgumentsAMXX.arg12
		);

		if( ret != RageHookIgnored )
		{
			break;
		}
	}

	this->disable_amxx_hook_functions();
}

void Handler::call_module_hooks( CVector<void*>& hooks, RageHookReturn& ret )
{
	if( ret != RageHookIgnored )
		return;

	if( !hooks.size() )
		return;

	Vector v2;
	v2.x = Data.Arguments.arg2.x;
	v2.y = Data.Arguments.arg2.y;
	v2.z = Data.Arguments.arg2.z;

	Vector v3;
	v3.x = Data.Arguments.arg3.x;
	v3.y = Data.Arguments.arg3.y;
	v3.z = Data.Arguments.arg3.z;

	for( unsigned int i = 0; i < hooks.size(); i++ )
	{
		ModuleHookType module_hook = (ModuleHookType) hooks[i];

		Data.ArgumentsAMXX.arg2 = MF_PrepareCellArray( reinterpret_cast< cell* >( &Data.Arguments.arg2 ), 3 );
		Data.ArgumentsAMXX.arg3 = MF_PrepareCellArray( reinterpret_cast< cell* >( &Data.Arguments.arg3 ), 3 );

		ret = module_hook
		(
			Data.Arguments.arg1,
			Data.Arguments.arg2,
			Data.Arguments.arg3,
			Data.Arguments.arg4,
			Data.Arguments.arg5,
			Data.Arguments.arg6,
			Data.Arguments.arg7,
			Data.Arguments.arg8,
			Data.Arguments.arg9,
			Data.Arguments.arg10,
			Data.Arguments.arg11,
			Data.Arguments.arg12,
			Data.Return
		);

		convertArgumentsToAMXX();

		if( ret != RageHookIgnored )
			return;
	}
}

int Handler::create_plugin_hook( AMX* amx, const char* function_name )
{
	return g_fn_RegisterSPForwardByName( amx, function_name, 
		FP_CELL, 
		FP_ARRAY, 
		FP_ARRAY, 
		FP_FLOAT, 
		FP_FLOAT, 
		FP_CELL, 
		FP_CELL, 
		FP_CELL, 
		FP_FLOAT, 
		FP_CELL, 
		FP_CELL, 
		FP_CELL, 
		FP_DONE );
}

cell Handler::rage_call( FunctionForHandler* function, AMX* amx, cell* params )
{
	unsigned int n_params = params[0] / sizeof(cell);

	if( n_params != 13 )
	{
		MF_LogError( amx, AMX_ERR_NATIVE, "rage_call invalid parameter count" );
		return 0;
	}

	GateType managed_address = (GateType) function->get_managed_address();
			
	void* arg1 = Rage->index_to_private(*MF_GetAmxAddr(amx,params[1]));

	Vector v2;
	float *fl2 = ( float* )MF_GetAmxAddr( amx, params[2] );
	v2.x = fl2[0];
	v2.y = fl2[1];
	v2.z = fl2[2];

	Vector v3;
	float *fl3 = ( float* )MF_GetAmxAddr( amx, params[3] );
	v3.x = fl3[0];
	v3.y = fl3[1];
	v3.z = fl3[2];

	float fl4 = Rage->amx_ctof2( *MF_GetAmxAddr( amx, params[4] ) ); 
	float fl5 = Rage->amx_ctof2( *MF_GetAmxAddr( amx, params[5] ) ); 

	int int6 = *MF_GetAmxAddr( amx, params[6] );
	int int7 = *MF_GetAmxAddr( amx, params[7] );
	int int8 = *MF_GetAmxAddr( amx, params[8] );

	float fl9 = Rage->amx_ctof2( *MF_GetAmxAddr( amx, params[9] ) ); 

	entvars_s* ent10 = Rage->index_to_entvar( *MF_GetAmxAddr( amx, params[10] ) );

	bool b11 = !!*MF_GetAmxAddr( amx, params[11] );
	int int12 = *MF_GetAmxAddr( amx, params[12] );

	Vector ret;

	#ifdef __linux__
		ret = managed_address( arg1, v2, v3, fl4, fl5, int6, int7, int8, fl9, ent10, b11, int12 );
	#else
		managed_address( arg1, DUMMY_VAL, &ret, v2, v3, fl4, fl5, int6, int7, int8, fl9, ent10, b11, int12 );
	#endif

	float *out = ( float* )MF_GetAmxAddr( amx, params[13] );
	out[0] = ret.x;
	out[1] = ret.y;
	out[2] = ret.z;

	return 1;
}

cell Handler::rage_set_param_invalid_point( AMX* amx,cell* params )
{
	MF_LogError( amx, AMX_ERR_NATIVE, "Can't call rage set param at this point" );
	return 0;
}

cell Handler::rage_set_param_normal( AMX* amx, cell* params )
{
	unsigned int n_params = params[0] / sizeof(cell);

	if( n_params != 2 )
	{
		MF_LogError( amx, AMX_ERR_NATIVE, "rage_set_param Invalid parameter count" );
		return 0;
	}

	switch( params[1] )
	{
		case 1:
		{
			Data.ArgumentsAMXX.arg1 = *MF_GetAmxAddr( amx, params[2] );
			Data.Arguments.arg1 = Rage->index_to_private( Data.ArgumentsAMXX.arg1 );
					
			break;
		}
		case 2:
		{
			Vector v2;
			float *fl2 = ( float* )MF_GetAmxAddr( amx, params[2] );
			v2.x = fl2[0];
			v2.y = fl2[1];
			v2.z = fl2[2];

			Data.ArgumentsAMXX.arg2 = MF_PrepareCellArray( reinterpret_cast< cell* >( &v2 ), 3 );
			Data.Arguments.arg2 = v2;

			break;
		}
		case 3:
		{
			Vector v3;
			float *fl3 = ( float* )MF_GetAmxAddr( amx, params[2] );
			v3.x = fl3[0];
			v3.y = fl3[1];
			v3.z = fl3[2];

			Data.ArgumentsAMXX.arg3 = MF_PrepareCellArray( reinterpret_cast< cell* >( &v3 ), 3 );
			Data.Arguments.arg3 = v3;

			break;
		}
		case 4 :
		{
			Data.Arguments.arg4 = Data.ArgumentsAMXX.arg4 = Rage->amx_ctof2( *MF_GetAmxAddr( amx, params[2] ) ); 
			break;
		}
		case 5 :
		{
			Data.Arguments.arg5 = Data.ArgumentsAMXX.arg5 = Rage->amx_ctof2( *MF_GetAmxAddr( amx, params[2] ) ); 
			break;
		}
		case 6 :
		{
			Data.Arguments.arg6 = Data.ArgumentsAMXX.arg6 = *MF_GetAmxAddr( amx, params[2] );
			break;
		}
		case 7 :
		{
			Data.Arguments.arg7 = Data.ArgumentsAMXX.arg7 = *MF_GetAmxAddr( amx, params[2] );
			break;
		}
		case 8 :
		{
			Data.Arguments.arg8 = Data.ArgumentsAMXX.arg8 = *MF_GetAmxAddr( amx, params[2] );
			break;
		}
		case 9 :
		{
			Data.Arguments.arg9 = Data.ArgumentsAMXX.arg9 = Rage->amx_ctof2( *MF_GetAmxAddr( amx, params[2] ) ); 
			break;
		}
		case 10 :
		{
			Data.ArgumentsAMXX.arg10 = *MF_GetAmxAddr( amx, params[2] );
			Data.Arguments.arg10 = Rage->index_to_entvar( Data.ArgumentsAMXX.arg10 );

			break;
		}
		case 11 :
		{
			Data.ArgumentsAMXX.arg11 = *MF_GetAmxAddr( amx, params[2] );
			Data.Arguments.arg11 = !!Data.ArgumentsAMXX.arg11;

			break;
		}
		case 12 :
		{
			Data.Arguments.arg12 = Data.ArgumentsAMXX.arg12 = *MF_GetAmxAddr( amx, params[2] );
			break;
		}
		default:
		{
			MF_LogError(amx, AMX_ERR_NATIVE, "Parameter out of range");
		}
	};

	return 1;
}

cell Handler::rage_set_param( AMX* amx, cell* params )
{
	return (this->*rage_set_param_current)(amx,params);
}

cell Handler::rage_set_return_invalid_point( AMX* amx, cell* params )
{
	MF_LogError( amx, AMX_ERR_NATIVE, "Can't call rage set return at this point" );
	return 0;
}

cell Handler::rage_set_return_normal( AMX* amx, cell* params )
{
	unsigned int n_params = params[0] / sizeof(cell);

	if( n_params != 1 )
	{
		MF_LogError( amx, AMX_ERR_NATIVE, "rage_set_return invalid parameter count" );
		return 0;
	}

	cell *cAddr = MF_GetAmxAddr( amx, params[1] );

	REAL fX = Rage->amx_ctof2( cAddr[0] );
	REAL fY = Rage->amx_ctof2( cAddr[1] );
	REAL fZ = Rage->amx_ctof2( cAddr[2] );

	Data.Return = Vector( fX, fY, fZ );

	return 1;
}

cell Handler::rage_set_return( AMX* amx, cell* params )
{
	return (this->*rage_set_return_current)( amx, params );
}

cell Handler::rage_get_return_invalid_point( AMX* amx, cell* params )
{
	MF_LogError( amx, AMX_ERR_NATIVE, "Can't call rage get return at this point" );
	return 0;
}

cell Handler::rage_get_return_pre( AMX* amx, cell* params )
{
	MF_LogError( amx, AMX_ERR_NATIVE, "Can't call rage get return in pre hooks" );
	return 0;
}

cell Handler::rage_get_return_normal( AMX* amx, cell* params )
{
	unsigned int n_params = params[0] / sizeof(cell);

	if( n_params != 1 )
	{
		MF_LogError( amx, AMX_ERR_NATIVE, "rage_get_return invalid parameter count" );
		return 0;
	}

	float* out = ( float* )MF_GetAmxAddr( amx, params[1] );
	out[0] = Data.Return.x;
	out[1] = Data.Return.y;
	out[2] = Data.Return.z;

	return 1;
}

cell Handler::rage_get_return( AMX* amx, cell* params )
{
	return (this->*rage_get_return_current)(amx,params);
}

Handler::Handler(char* name) : name(name)
{
	disable_amxx_hook_functions();
}

void Handler::disable_amxx_hook_functions()
{
	this->rage_get_return_current = &Handler::rage_get_return_invalid_point;
	this->rage_set_return_current = &Handler::rage_set_return_invalid_point;
	this->rage_set_param_current = &Handler::rage_set_param_invalid_point;
}

char* Handler::get_name()
{
	return this->name;
}

void* Handler::get_gate_address()
{
	return (void*)&Gate;
}

int Handler::AMXX_Detach()
{
#ifdef FN_AMXX_DETACH
	FN_AMXX_DETACH();
#endif // FN_AMXX_DETACH

	return AMXX_OK;
}

int Handler::AMXX_PluginsLoaded()
{
#ifdef FN_AMXX_PLUGINSLOADED
	FN_AMXX_PLUGINSLOADED();
#endif // FN_AMXX_PLUGINSLOADED
	return AMXX_OK;
}

void Handler::AMXX_PluginsUnloaded()
{
#ifdef FN_AMXX_PLUGINSUNLOADED
	FN_AMXX_PLUGINSUNLOADED();
#endif // FN_AMXX_PLUGINSUNLOADED
}

void Handler::AMXX_PluginsUnloading()
{
#ifdef FN_AMXX_PLUGINSUNLOADING
	FN_AMXX_PLUGINSUNLOADING();
#endif // FN_AMXX_PLUGINSUNLOADING
}
