
#ifndef _INCLUDE_HANDLER__H_
#define _INCLUDE_HANDLER__H_

#include <handler/handler_for_rage.h>
#include <rage/rage_for_handler.h>
#include <rage/rage_hook_return.h>
#include <rage/rage_hook_phase.h>
#include <CVector.h>

typedef int DUMMY;
const int DUMMY_VAL = 0;

extern RageForHandler* Rage;

class Handler : public HandlerForRage
{
	private:
		
		char* name;
		
		struct ArgumentsType
		{
			void*		arg1;
			Vector		arg2;
			Vector		arg3;
			float		arg4;
			float		arg5;
			int			arg6;
			int			arg7;
			int			arg8;
			float		arg9;
			entvars_s*	arg10;
			bool		arg11;
			int			arg12;
		};

		struct ArgumentsAMXXType
		{
			int			arg1;
			cell 		arg2;
			cell 		arg3;
			float		arg4;
			float		arg5;
			int			arg6;
			int			arg7;
			int			arg8;
			float		arg9;
			int			arg10;
			int			arg11;
			int			arg12;
		};

		struct 
		{
			ArgumentsType Arguments;
			ArgumentsAMXXType ArgumentsAMXX;
			Vector Return;
		} Data;

		cell (Handler::*rage_set_param_current)(AMX* amx,cell* params);
		cell (Handler::*rage_get_return_current)(AMX* amx,cell* params);
		cell (Handler::*rage_set_return_current)(AMX* amx,cell* params);

	public:
		
		Handler(char* name);

		char* get_name();
		void* get_gate_address();

		typedef RageHookReturn (*ModuleHookType)( void*&, Vector&, Vector&, float&, float&, int&, int&, int&, float&, entvars_s*&, bool&, int&, Vector& );

#ifdef __linux__
		static Vector Gate( void*, Vector, Vector, float, float, int, int, int, float, entvars_s*, bool, int );
		typedef Vector (*GateType)( void*, Vector, Vector, float, float, int, int, int, float, entvars_s*, bool, int );
#else
		static Vector* _fastcall Gate( void*, DUMMY, Vector* origReturn, Vector, Vector, float, float, int, int, int, float, entvars_s*, bool, int );
		typedef Vector* (_fastcall *GateType)( void*, DUMMY, Vector* origReturn, Vector, Vector, float, float, int, int, int, float, entvars_s*, bool, int );
#endif
		
		void init( void* arg1, Vector arg2, Vector arg3, float arg4, float arg5, int arg6, int arg7, int arg8, float arg9, entvars_s* arg10, bool arg11, int arg12 );
		void convertArgumentsToAMXX();
		void call_original(FunctionForHandler* function,RageHookReturn& ret);
		Vector end();

		void call_plugin_hooks(CVector<int>& hooks,RageHookReturn& ret, RageHookPhase rage_hook_phase);
		void call_module_hooks(CVector<void*>& hooks,RageHookReturn& ret);
		int create_plugin_hook(AMX* amx,const char* function_name);
		cell rage_call(FunctionForHandler* function,AMX* amx,cell* params);
		cell rage_set_param_invalid_point(AMX* amx,cell* params);
		cell rage_set_param_normal(AMX* amx,cell* params);
		cell rage_set_param(AMX* amx,cell* params);
		cell rage_set_return_invalid_point(AMX* amx,cell* params);
		cell rage_set_return_normal(AMX* amx,cell* params);
		cell rage_set_return(AMX* amx,cell* params);
		cell rage_get_return_invalid_point(AMX* amx,cell* params);
		cell rage_get_return_pre(AMX* amx,cell* params);
		cell rage_get_return_normal(AMX* amx,cell* params);
		cell rage_get_return(AMX* amx,cell* params);
		
		void disable_amxx_hook_functions();
		
		int AMXX_Detach();
		int AMXX_PluginsLoaded();
		void AMXX_PluginsUnloaded();
		void AMXX_PluginsUnloading();
};

#endif
